
#cs
	######################################################################################################################################################

	v1.3
	Quelle: https://www.autoitscript.com/forum/topic/163125-updateautoupdate-functions/

	Umgebaut von Thorsten Müll (Habe das dort gefundene Script für den Einsatz bei uns mittels Freigaben stark abgewandelt und vereinfacht)


	TODO: UDF nach Empfehlung aufbauen: https://www.autoitscript.com/wiki/UDF-spec


	Diese UDF führt ein automatisches Update des Programms durch, wenn die Version auf dem Server (muss hier liegen: $sUpdateServer_Pfad)ungleich ist mit der aktuell installierten Version.
	Somit kann ein Upgrade ODER ein Downgrade durchgeführt werden.
	Das Programm stürzt nicht ab, wenn auf der Freigabe nichts liegt oder wenn die Freigabe nicht erreichbar ist. Das wird dann nur im Log protokolliert.
	Das schöne ist, dass nach dem Update das Programm wieder gestartet wird und die ursprünglichen Parameter übergeben werden. :-)

	Änderungshistorie:
	v1.1: Eintrag der aktuell installierten Version in INI nach folgendem Muster:   S108=1.2.0.0
	v1.2: Die Freigabe für die Updates kann umziehen , d.h. man legt auf der alten Freigabe eine Datei "Umleitung.ini" an und wenn die korrekt ausgefüllt wurde und die neue Freigabe auch tatsächlich existiert,
	dann überschreibt der AutoUpdater seine fest eingebaute Variable mit dem neuen Pfad.
	v1.3: Doku überarbeitet


	Wunschliste:
	-	Mittels einer bestimmten Datei soll der Updater optional angewiesen werden, noch zusätzliche Dateien (z.B. Konfig.ini) mit zu installieren oder auszutauschen.



	WICHTIG:
	Es muss ZUVOR die Logs.au3 inkludiert werden, weil diese UDF hier auch Logs schreibt.



	>>> Folgende Zeilen müssen unbedingt ins Hauptprogramm eingebaut werden:

	----------------------------------------------------------
	Global $iDebuglevel = 1     ; 0 --> nur "DebugToLog(1, ...)" wird ins Log geschrieben   |   1 --> auch "DebugToLog(1, ...)" wird ins Log geschrieben
	Global $iRemainingDays = 7	;Tage, wie lange die logs behalten werden.
	#include <include\Logs.au3>

	Global $sUpdateServer_Pfad = "\\xserve\IT-Allgemein\_Programme Mac Win\Programme_aus_Webbrowser_starten\"   ; <<<--- hier den Pfad zur Freigabe angeben, wo die neueste Version abgelegt wird
	#include <AutoUpdate.au3>
	----------------------------------------------------------


	Beispiel zur Verwendung:

	----------------------------------------------------------
	DebugToLogLine(0, "########################################## Programm Version: " & $ProgVersion)
	DebugToLog(0, "Programm gestartet mit Parameter: " & $CmdLineRaw & @CRLF)


	If @Compiled Then
	DebugToLogLine(0, "Prüfe auf Updates...")
	UpdateCheck()
	EndIf
	-------------------------------------------------------------


	######################################################################################################################################################
#ce



Func UpdateCheck()
	Local $sIniDateiName = "Info.ini"
	Local $sCurrentVersion = FileGetVersion(@AutoItExe) ; checke Version der aktuell installierten EXE
	DebugToLog(0, "aktuell installierte Version: " & $sCurrentVersion & @CRLF)

	; schreibe aktuelle Version in die INI:
	Local $iIniWriteErfolg = IniWrite($sUpdateServer_Pfad & $sIniDateiName, "Installiert_auf_Computer", @ComputerName, $sCurrentVersion)
	If $iIniWriteErfolg = 1 Then
		DebugToLog(0, "Eintrag der aktuell installierten Version in INI war erfolgreich." & @CRLF)
	Else
		DebugToLog(0, ">>>>>>>  Fehler bei Eintrag der aktuell installierten Version in INI: " & $sUpdateServer_Pfad & "computer.ini" & @CRLF)
	EndIf

	; Prüfe, ob sich die Freigabe geändert hat...
	If FileExists($sUpdateServer_Pfad & "Umleitung.ini") Then
		Local $sUpdateServer_Pfad_neu = IniRead($sUpdateServer_Pfad & "Umleitung.ini", "Neue_Freigabe", "UpdateServer_Pfad", $sUpdateServer_Pfad)
		If $sUpdateServer_Pfad_neu <> $sUpdateServer_Pfad Then
			DebugToLog(0, "Habe Befehl zur Umstellung auf neue Freigabe erhalten:" & $sUpdateServer_Pfad_neu & @CRLF)
			If FileExists($sUpdateServer_Pfad_neu) Then
				Local $iIniWriteErfolg = IniWrite($sUpdateServer_Pfad & $sIniDateiName, "auf_neue_Freigabe_umgestellt", @ComputerName, _NowCalc())
				If $iIniWriteErfolg = 1 Then
					DebugToLog(0, "Eintrag der Umstellung auf neue Freigabe in INI war erfolgreich." & @CRLF)
				Else
					DebugToLog(0, ">>>>>>>  Fehler bei Eintrag der Umstellung auf neue Freigabe in INI: " & $sUpdateServer_Pfad & "computer.ini" & @CRLF)
				EndIf
				$sUpdateServer_Pfad = $sUpdateServer_Pfad_neu
			Else
				DebugToLog(0, ">>>>>>>  Fehler!  Neue Freigabe existiert nicht. Umstellung auf neue Freigabe ist nicht erfolgt!" & @CRLF)
			EndIf
		EndIf
	EndIf

	If Not FileExists($sUpdateServer_Pfad & @ScriptName) Then
		DebugToLog(0, ">>>>>  Fehler! Kann die folgende Datei nicht auf dem Updateserver finden: " & $sUpdateServer_Pfad & @ScriptName & @CRLF)
	Else
		Local $sVersion_auf_Server = FileGetVersion($sUpdateServer_Pfad & @ScriptName) ; checke Version der EXE auf Server
		$sLatestVersion = BinaryToString($sVersion_auf_Server, 1) ;get latest version
		DebugToLog(0, "Version auf Server: " & $sLatestVersion & @CRLF)

		If $sCurrentVersion = $sLatestVersion Then
			;MsgBox(64, "Update Check", "You are running the latest version: " & $sCurrentVersion)
			DebugToLog(0, "Es wird bereits die neueste Version genutzt." & @CRLF)
		Else
			DebugToLog(0, "Es liegt ein Update vor, installiere jetzt die neueste Version..." & @CRLF)
			Update()
		EndIf
	EndIf
EndFunc   ;==>UpdateCheck


Func Update()
	Local $sUpdateScript = @TempDir & "\updatescript.cmd" ; Batchscript muss im Temp-Ordner liegen. Wenn es im ScriptDir liegt und der Prozess von Firefox gestartet wird, kann die Datei nicht erstellt werden.
	If Not FileExists($sUpdateServer_Pfad & @ScriptName) Then
		;MsgBox(64, "Update Check", "Kann die folgende Datei nicht auf dem Updateserver finden: " & $sUpdateServer_Pfad & @ScriptName)
		DebugToLog(0, ">>>>>  Fehler! Kann die folgende Datei nicht auf dem Updateserver finden: " & $sUpdateServer_Pfad & @ScriptName & @CRLF)
	Else ;success, write batch script
		DebugToLog(0, "Starte die Erzeugung des Update-Scripts. Parameter für Programmstart: " & $CmdLineRaw & @CRLF)

		Local $sTempFileName = @ScriptDir & "\" & @ScriptName & "_temp"
		FileCopy($sUpdateServer_Pfad & @ScriptName, $sTempFileName)
		$exename = @ScriptFullPath
		$pid = @AutoItPID
		Local $hFileHandle = FileOpen($sUpdateScript, 1)
		If $hFileHandle = -1 Then
			DebugToLog(0, "Fehler beim Anlegen der Datei: " & $sUpdateScript & @CRLF)
		Else
			FileWriteLine($hFileHandle, "@echo off")
			FileWriteLine($hFileHandle, ":loop")
			FileWriteLine($hFileHandle, "tasklist /fi " & '"pid eq ' & $pid & '" | find ":" > nul') ;batch file won't continue until old autoit exe process id terminates
			FileWriteLine($hFileHandle, "if errorlevel 1 (")
			FileWriteLine($hFileHandle, "  ping 127.0.0.1 -n 2")
			FileWriteLine($hFileHandle, "  goto loop")
			FileWriteLine($hFileHandle, ") else (")
			FileWriteLine($hFileHandle, "  goto continue")
			FileWriteLine($hFileHandle, ")")
			FileWriteLine($hFileHandle, ":continue")
			FileWriteLine($hFileHandle, 'del "' & $exename & '"') ;deletes old exe
			FileWriteLine($hFileHandle, 'move "' & $sTempFileName & '" "' & $exename & '"') ;renames new exe to the same name
			FileWriteLine($hFileHandle, 'start "" ' & '"' & $exename & '" ' & $CmdLineRaw) ;launches with any parameters the old exe had
			;FileWriteLine($hFileHandle, "pause")
			FileWriteLine($hFileHandle, "start /b """" cmd /c del ""%~f0""&exit /b") ;batch file self deletes
			FileClose($hFileHandle)

			DebugToLog(0, "Update-Script: " & @CRLF & FileRead($sUpdateScript) & @CRLF)
			Run($sUpdateScript, @ScriptDir, @SW_HIDE) ;launch batch file in hidden mode
			Exit ;exit so batch file can continue
		EndIf
	EndIf
EndFunc   ;==>Update
