#include-once
AutoItSetOption("MustDeclareVars", 0)
#include <Date.au3>
#include <File.au3>

#cs
	######################################################################################################################################################

	v1.0

	TODO: UDF nach Empfehlung aufbauen: https://www.autoitscript.com/wiki/UDF-spec


	Beispiel zur Verwendung:

	DebugToLog(0, ">>>> Fehler! Paketaufkleberdatei konnte NICHT im Erfolgsordner abgelegt werden: " & $PaketaufkleberDateiname_mit_Ablageordner)


	Erklärung:

	DebugToLog(0, "...") = immer ins Logfile schreiben
	DebugToLog(1, "...") = wird nur ins Logfile geschrieben, wenn Debuglevel = 1  --> hierzu die folgende Zeile ins Hauptprogramm ganz oben einfügen


	Global $iDebuglevel = 1     ; 0 --> nur "DebugToLog(1, ...)" wird ins Log geschrieben   |   1 --> auch "DebugToLog(1, ...)" wird ins Log geschrieben
	Global $iRemainingDays = 7	;Tage, wie lange die logs behalten werden.
	#include <include\Logs.au3>

	WICHTIG: "$iDebugLevel, $iRemainingDays..." muss VOR "#include..." stehen, sonst werden sie ignoriert!
	LogFileAufraeumen() muss manuel aufgerufen werden


	######################################################################################################################################################
#ce
;Global $iDebuglevel = 1     ; 0 --> nur "DebugToLog(1, ...)" wird ins Log geschrieben   |   1 --> auch "DebugToLog(1, ...)" wird ins Log geschrieben
;Global $iRemainingDays = 7	;Tage, wie lange die logs behalten werden.
Local $LogDir = @ScriptDir & "\Log\"
DirCreate($LogDir)
Local $Logfile
Local $LogfileSetAt
Local $sNameWithoutEnding = StringTrimRight(@ScriptName,4)
If Not @Compiled Then
	$asTemp = StringSplit($sNameWithoutEnding,"__", 1)
	$sNameWithoutEnding = $asTemp[1]
EndIf

SetLogfile()
LogFileAufraeumen()

Func SetLogfile()
	$LogfileSetAt = _NowCalcDate()
	If @Compiled Then
		$Logfile = $LogDir & $sNameWithoutEnding & "__" & @YEAR & "-" & @MON & "-" & @MDAY & "_v" & FileGetVersion(@ScriptFullPath) & ".log" ; Retrieve the name of weekday
	Else
		$Logfile = $LogDir & $sNameWithoutEnding & "__" & @YEAR & "-" & @MON & "-" & @MDAY & ".log" ; Retrieve the name of weekday
	EndIf
	;DebugToLogLine(0,$sNameWithoutEnding & " " &$Logfile)
EndFunc

Func FehlerToLogLine($sFehlertext)
	FehlerToLog($sFehlertext & @CRLF)
EndFunc

Func FehlerToLog($sFehlertext)
	DebugToLog(0, ">>> Fehler: " & $sFehlertext)
EndFunc

Func WarnungToLogLine($iDebugWichtigkeit, $sWarnungtext)
	WarnungToLog($iDebugWichtigkeit, $sWarnungtext & @CRLF)
EndFunc

Func WarnungToLog($iDebugWichtigkeit, $sWarnungtext)
	DebugToLog($iDebugWichtigkeit, ">>> Warnung: " & $sWarnungtext)
EndFunc

Func DebugToLogLine($iDebugWichtigkeit, $sDebugtext)
	DebugToLog($iDebugWichtigkeit, $sDebugtext & @CRLF)
EndFunc   ;==>DebugToLogLine

Func DebugToLog($iDebugWichtigkeit, $sDebugtext)
	; $DebugText wird immer in der Console ausgegeben:
	ConsoleWrite($sDebugtext)

	If _DateDiff('D', $LogfileSetAt, _NowCalcDate()) > 0 Then
		SetLogfile()
		LogFileAufraeumen()
	EndIf

	If $iDebugWichtigkeit = 0 Then ; DebugToLog(0, "...") = immer ins Logfile Schreiben
		_FileWriteLog($Logfile, $sDebugtext)
	ElseIf $iDebugLevel = 1 And $iDebugWichtigkeit = 1 Then ; wenn DebugToLog(1, "...") UND Debuglevel = 1   -->> ins Logfile schreiben
		_FileWriteLog($Logfile, $sDebugtext)
	EndIf
EndFunc   ;==>DebugToLog


Func LogFileAufraeumen()
	; prüfe Erstellungsdatum der aktuellen Logdatei und lösche diese, wenn 7 Tage alt, oder älter
	Local $sSearchString = $sNameWithoutEnding & "__*.log"
	Local $asFiles =_FileListToArray($LogDir, $sSearchString, 1)
	Switch @error
		Case 1
			DebugToLog(0,"Folder not found or invalid."& @CRLF )
			Return
		Case 2
			DebugToLog(0,"Invalid Filter"& @CRLF  )
			Return
		Case 3
			DebugToLog(0,"Invalid Flag"& @CRLF  )
			Return
		Case 4
			DebugToLog(0,"No Files found in " & $LogDir& @CRLF  )
			Return
		Case 0
			DebugToLogLine(0,$asFiles[0] & ' Log-Files with search string "' & $sSearchString & '" found.')
	EndSwitch

	Local $iCounterDeleted = 0
	For $i = 1 To $asFiles[0]
		Local $sFileNameAndPath = $LogDir & $asFiles[$i]
		Local $FileDate = FileGetTime($sFileNameAndPath, 0) ; 0 = modification / 1 = creation
		If Not IsArray($FileDate) Then ContinueLoop

		Local $Date = $FileDate[0] & '/' & $FileDate[1] & '/' & $FileDate[2] & ' ' & $FileDate[3] & ':' & $FileDate[4] & ':' & $FileDate[5]
		If _DateDiff('D', $Date, _NowCalc()) > $iRemainingDays Then
			DebugToLog(0,"Logdatei " & $asFiles[$i] & " ist über " & $iRemainingDays & " Tage alt, wird nun gelöscht!" & @CRLF)
			FileDelete($sFileNameAndPath)
			If @error Then DebugToLog(0,"FileDelete($sFileNameAndPath) - @error: " & @error & @CRLF)
			$iCounterDeleted += 1
		EndIf
	Next
	Local $sLogString = "Es wurde"
	Switch $iCounterDeleted
		Case 0
			$sLogString &= "n keine Log-Dateien"
		Case 1
			$sLogString &= " eine Log-Datei"
		Case Else
			$sLogString &= "n " & $iCounterDeleted & " Log-Dateien"
	EndSwitch
	DebugToLogLine(0, $sLogString & " (älter als " & $iRemainingDays & " Tage) gelöscht. ")

EndFunc   ;==>LogFileAufraeumen