#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=NetzwerkDiagnose.ico
#AutoIt3Wrapper_Outfile=\\XSERVE\IT-Allgemein\_Programme Mac Win\Netzwerk Diagnose\NetzwerkDiagnose.exe
#AutoIt3Wrapper_Res_Comment=Netzwerk Diagnose
#AutoIt3Wrapper_Res_Fileversion=1.5.1.13
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_LegalCopyright=|©Thomas Zickert, Druckhaus Harms e.K.  |  2017
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/mo
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs###################################################################################################################################################################
	##################################################################################################################################################################
	##################################################################################################################################################################
	#######     																																			   #######
	#######    Author: Thomas Zickert                          																							       #######
	#######	   Script Funktion:																																   #######
	#######    Netzwerkinfo + Zugriff Diagnose 																						 						   #######
	#######																																					   #######
	#######	   26.06.17																																		   #######
	#######																																					   #######
	##################################################################################################################################################################
	##################################################################################################################################################################
#ce###################################################################################################################################################################


#include <Array.au3>
$iTimer = TimerInit()
$aAdapter = _Win32NetworkAdapter()

#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <WindowsConstants.au3>
#include <ColorConstants.au3>
#include <GUIConstantsEx.au3>
#include <MsgBoxConstants.au3>



#cs#########################################################################################################
	############################################################################################################
	###																										 ###
	### 									Funktionen  													 ###
	###																										 ###
	############################################################################################################
#ce#########################################################################################################

#include <File.au3>

#cs################################
	#######   AUTO Update   #######
#ce################################

Global Const $ProgVersion = getVersion()


;LOGS
Global $iDebuglevel = 1 ; 0 --> nur "DebugToLog(1, ...)" wird ins Log geschrieben   |   1 --> auch "DebugToLog(1, ...)" wird ins Log geschrieben
Global $iRemainingDays = 7 ;Tage, wie lange die logs behalten werden.
#include <include\Logs.au3>

;Autoupdate
Global $sUpdateServer_Pfad = "\\xserve\IT-Allgemein\_Programme Mac Win\Netzwerk Diagnose\" ; <<<--- hier den Pfad zur Freigabe angeben, wo die neueste Version abgelegt wird
#include <include\AutoUpdate.au3>

DebugToLogLine(0, "########################################## Programm Version: " & $ProgVersion)

If @Compiled Then
	DebugToLogLine(0, "Prüfe auf Updates...")
	UpdateCheck()
EndIf

Func getVersion()
	If @Compiled Then
		Return FileGetVersion(@ScriptFullPath)
	Else
		Local $aTemp, $found
		If _FileReadToArray(@ScriptFullPath, $aTemp) <> 1 Then Return 'unknown' ; script konnte nicht in array gelesen werden
		$found = _ArraySearch($aTemp, "#AutoIt3Wrapper_Res_Fileversion=", 1, 0, 0, 1)
		If $found = -1 Then Return 'unknown' ; Suche war erfolglos
		If StringInStr($aTemp[$found], "_ArraySearch", 1) Then Return 'unknown' ; verhindert, dass Quellcode ausgegeben wird, wenn keine Version Ressource gesetzt wurde...
		Return StringReplace($aTemp[$found], "#AutoIt3Wrapper_Res_Fileversion=", "") ; alles ok ;)
	EndIf
EndFunc   ;==>getVersion


#CS#####   Mac Ermittlung   #####
#ce############################## ausgabe = $strmac

$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colAdapters = $objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = True")
$strmac = ''

For $objAdapter In $colAdapters

	$strmac &= $objAdapter.MACAddress & " "
Next
;MsgBox(512 + 1 +4096 + 64 + 8192 + 65536,"Netzwerkinfo",$strmac)


#CS#####   Verbindungsart   #####
#ce############################## ;ausgabe = $stradapter

$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colItems = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapter WHERE Netconnectionstatus = 2', 'WQL', 0x30)
$stradapter = ''
$strlan = ''
$strwlan = ''
For $objItem In $colItems
	$stradapter &= $objItem.NetConnectionID & @LF


	If StringRegExp($stradapter, "WLANE"&"Ethernet", 0 ) Then
		$strwlan = "Verbunden"

		$strlan = "Verbunden"

	Else
		If StringRegExp($stradapter, "Ethernet", 0 ) Then
			$strlan = "Verbunden"
		Else
			$strlan = "nicht Verbunden"
		EndIf

		If StringRegExp($stradapter, "WLAN", 0 ) Then
			$strwlan = "Verbunden"
		Else
			$strwlan = "nicht Verbunden"
		EndIf
	EndIf

Next
ConsoleWrite($stradapter)
;MsgBox(512 + 1 + 4096 + 64 + 8192 + 65536, "Netzwerkinfo", $stradapter)


#CS#####   DHCP Server IP   #####
#ce############################## ;ausgabe = $strdhcpserver

$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colItems2 = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration', 'WQL', 0x30)
$strdhcpserver = ''
For $objItem2 In $colItems2
	$strdhcpserver &= $objItem2.DHCPServer & " "
Next
;MsgBox(0,"Netzwerkinfo",$strdhcpserver)

#CS#####   DHCP Server konfiguration   #####
#ce######################################### ;ausgabe = $srtdhcpstatus

$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colItems2 = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration', 'WQL', 0x30)
$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colItems = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapter WHERE Netconnectionstatus = 2', 'WQL', 0x30)
$srtdhcpstatus = ''


For $objItem In $colItems
	For $objItem2 In $colItems2
		If $objItem.Caption = $objItem2.Caption Then
			If $objItem2.IPEnabled = -1 Then
				If $objItem2.DHCPEnabled = -1 Then
					$srtdhcpstatus &= 'von DHCP zugewiesen'
				Else
					$srtdhcpstatus &= 'Manuell konfiguriert'
				EndIf

			EndIf
		EndIf
	Next
Next

; MsgBox(0,"Netzwerkinfo",$srtdhcpstatus)

#CS#####   IP Gateway   #########
#ce############################## ;ausgabe = $strgateway

$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colItems2 = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration', 'WQL', 0x30)
$strgateway = ''
For $objItem2 In $colItems2
	$strgateway &= $objItem2.DefaultIPGateway(0) & " "
Next
;MsgBox(0,"Netzwerkinfo",$strgateway)


#CS#####   IP Adresse   #########
#ce############################## ;ausgabe = $strip

$strComputer = "."
$objWMIService = ObjGet("winmgmts:" & "{impersonationLevel=impersonate}!\\" & $strComputer & "\root\cimv2")
$colItems2 = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration', 'WQL', 0x30)
$strip = ''
For $objItem2 In $colItems2
  	$strip &= $objItem2.IPAddress(0) & " "
Next
;MsgBox(0,"Netzwerkinfo",$strip)################## habe ein leerzeichen eingebaut und das label anschließend nach links verschoben


#CS#####   DC1 Erreichbar?   #####
#ce###############################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.1"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortdc1 = "Erreichbar"
Else
	$srtantwortdc1 = "nicht Erreichbar"
EndIf
;MsgBox (0," ", $srtantwortdc1)


#CS#####   DC2 Erreichbar?   #####
#ce###############################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.2"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortdc2 = "Erreichbar"
Else
	$srtantwortdc2 = "nicht Erreichbar"
EndIf


#CS#####   xserve Erreichbar?   #####
#ce##################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.100"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortxserve = "Erreichbar"
Else
	$srtantwortxserve = "nicht Erreichbar"
EndIf


#CS#####   Datev-Server Erreichbar?   #####
#ce########################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.150"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortdatev = "Erreichbar"
Else
	$srtantwortdatev = "nicht Erreichbar"
EndIf


#CS#####   ZEUS-Server Erreichbar?   #####
#ce#######################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.46"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortzeus = "Erreichbar"
Else
	$srtantwortzeus = "nicht Erreichbar"
EndIf


#CS#####   Easylog-Server Erreichbar?   #####
#ce##########################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.50"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortelog = "Erreichbar"
Else
	$srtantwortelog = "nicht Erreichbar"
EndIf


#CS#####   Haupt-DNS-Server Erreichbar?   #####
#ce##########################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.1"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortdns1 = "Erreichbar"
Else
	$srtantwortdns1 = "nicht Erreichbar"
EndIf


#CS#####   GBD Chat Erreichbar?   #####
#ce####################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "192.168.100.14"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortchat = "Erreichbar"
Else
	$srtantwortchat = "nicht Erreichbar"
EndIf


#CS#####   Google Erreichbar?   #####
#ce##################################

Opt("TCPTimeout", 3000)
TCPStartup()
$szIPADDRESS = "8.8.8.8"
$pingzeit = Ping($szIPADDRESS, 1000)
If $pingzeit <> 0 Then ;wenn Rechner per ping erreichbar, dann
	$srtantwortgoogle = "Erreichbar"
Else
	$srtantwortgoogle = "nicht Erreichbar"
EndIf


#cs###################################################
#######										   #######
#######          Funktion der InfoBox          #######
#######										   #######
#ce###################################################

AdlibRegister ("_Win32NetworkAdapter")

Func _Win32NetworkAdapter($strComputer = 'Localhost')
    Local $aReturn[1][12] = [[ _
            'Hersteller:', 'Name:', 'Adapter-Typ:', 'Kennung:', _
            'MAC-Adresse:', 'Adresstyp:', 'DHCP-Server:', 'IP erhalten:', _
            'IP läuft ab:', 'IP-Adresse:', 'Subnetzmaske:', 'Standardgateway:']]
    Local $x = 0, $objWMIService, $colItems
    $objWMIService = ObjGet('winmgmts:\\' & $strComputer & '\')
    If Not IsObj($objWMIService) Then Return SetError(1, 0, 0)
    $colItems = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapter WHERE Netconnectionstatus = 2', 'WQL', 0x30)
    If Not IsObj($colItems) Then Return SetError(2, 0, 0)
    For $objItem In $colItems
        $x += 1
        ReDim $aReturn[$x + 1][12]
        $aReturn[$x][0] = $objItem.Manufacturer
        $aReturn[$x][1] = $objItem.Name
        $aReturn[$x][2] = $objItem.AdapterType
        $aReturn[$x][3] = $objItem.NetConnectionID
        $aReturn[$x][4] = $objItem.MACAddress
        $colItems2 = $objWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration', 'WQL', 0x30)
        If IsObj($colItems2) Then
            For $objItem2 In $colItems2
                If $objItem.Caption = $objItem2.Caption Then
                    If $objItem2.IPEnabled = -1 Then
                        If $objItem2.DHCPEnabled = -1 Then
                            $aReturn[$x][5] = 'von DHCP zugewiesen'
                            $aReturn[$x][6] = $objItem2.DHCPServer
                            $aReturn[$x][7] = _WMIDateStringToDate($objItem2.DHCPLeaseObtained)
                            $aReturn[$x][8] = _WMIDateStringToDate($objItem2.DHCPLeaseExpires)
                        Else
                            $aReturn[$x][5] = 'Manuell konfiguriert'
                        EndIf
                        $aReturn[$x][9] = $objItem2.IPAddress(0)
                        $aReturn[$x][10] = $objItem2.IPSubnet(0)
                        $aReturn[$x][11] = $objItem2.DefaultIPGateway(0)
                    EndIf
                EndIf
            Next
        EndIf
    Next
    Return $aReturn

EndFunc   ;==>_Win32NetworkAdapter
Func _WMIDateStringToDate($dtmDate)
    Return (StringMid($dtmDate, 5, 2) & '/' & _
            StringMid($dtmDate, 7, 2) & '/' & StringLeft($dtmDate, 4) _
             & ' ' & StringMid($dtmDate, 9, 2) & ':' & StringMid($dtmDate, 11, 2) & ':' & StringMid($dtmDate, 13, 2))
EndFunc   ;==>_WMIDateStringToDate





$OS = RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion","ProductName")
$winver = RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion","ReleaseId")



#Region ### START Koda GUI section ### Form=c:\users\zickert.thomas\documents\diagnose.kxf
$gui1 = GUICreate("Netzwerk Diagnose", 1306, 938, 450,20)
GUISetFont(14, 400, 0, "Arial")
$Gereateinfo = GUICtrlCreateGroup("Geräte Info", 24, 24, 425, 169)
GUICtrlSetFont(-1, 20, 400, 0, "Arial")
$Rechnernamefrage = GUICtrlCreateLabel("Rechnername:", 40, 80, 182, 36)
$Rechnernameant = GUICtrlCreateLabel(@ComputerName, 210, 80, 200, 17)
$Windowsver = GUICtrlCreateLabel("Windows Version:", 40, 136, 223, 36)
$winverantwort = GUICtrlCreateLabel($OS & @CRLF & "Version" & " " & $winver, 210, 136, 150, 45)
;$Button2_2 = GUICtrlCreateButton("Geräte" & @CRLF & "Manager", 320, 60,100,50,$BS_MULTILINE)
;$Button2_3 = GUICtrlCreateButton("Windows" & @CRLF & "Info", 320, 120,100,50,$BS_MULTILINE)
$Button2_3 = GUICtrlCreateButton("", 377, 90,50,50,$BS_ICON)
GUICtrlSetImage(-1, "DDORes.dll", 1)
;tab2
$Adapterinfo = GUICtrlCreateGroup("Adapter Info", 24, 224, 425, 193)
GUICtrlSetFont(-1, 20, 400, 0, "Arial")
$Lan = GUICtrlCreateLabel("LAN:", 40, 288, 64, 36)
$LA = GUICtrlCreateIcon("\\XSERVE\IT-Allgemein\_Programme Mac Win\Netzwerk Diagnose\ICO\lan_icon.ico", -1, 112, 275, 49, 49)
$lanantwort = GUICtrlCreateLabel($strlan, 208, 288, 135, 36)
$Wlanfrage = GUICtrlCreateLabel("WLAN:", 40, 350, 92, 36)
$Wlan = GUICtrlCreateIcon("\\XSERVE\IT-Allgemein\_Programme Mac Win\Netzwerk Diagnose\ICO\wlan-icon-6.ico", -1, 127, 333, 49, 49)
$wlanantwort = GUICtrlCreateLabel($strwlan, 208, 350, 205, 36)
$Button2_10 = GUICtrlCreateButton("", 377, 300,50,50,$BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 19)
;tab3
$Netzwekinfo = GUICtrlCreateGroup("Netzwerkinfo", 504, 24, 777, 393)
GUICtrlSetFont(-1, 20, 400, 0, "Arial")
$Button2_1 = GUICtrlCreateButton("Alle" & @CRLF & "aktiven"& @CRLF &"Adapter", 1050, 140,170,170,$BS_MULTILINE)
$ipadresse = GUICtrlCreateLabel("IP Adresse:", 520, 80, 145, 36)
$macadresse = GUICtrlCreateLabel("MAC Adresse:", 520, 136, 181, 36)
$adresstyp = GUICtrlCreateLabel("Adresstyp:", 520, 192, 134, 36)
$dhcpserver = GUICtrlCreateLabel("DHCP-Server:", 520, 248, 177, 36)
$standardgateway = GUICtrlCreateLabel("DHCP-Server IP:", 520, 304, 223, 36)
$SSID = GUICtrlCreateLabel("Standardgateway:", 520, 360, 476, 36)
$ipantwort = GUICtrlCreateLabel($strip, 760, 79, 135, 20);753
$macantwort = GUICtrlCreateLabel($strmac, 765, 135, 244, 20)
$Adapterantwort = GUICtrlCreateLabel($srtdhcpstatus, 765, 191, 245, 36)
$dhcpantwort = GUICtrlCreateLabel(@LogonDNSDomain & @LogonServer, 765, 247, 245, 36)
$standardgatewa = GUICtrlCreateLabel($strdhcpserver, 760, 303, 200, 20);745
$ssidantwort = GUICtrlCreateLabel($strgateway, 760, 359, 200, 20)
;tab4
$serverdiagnose = GUICtrlCreateGroup("Server", 24, 496, 577, 393, -1, $WS_EX_TRANSPARENT)
GUICtrlSetFont($serverdiagnose, 20, 400, 0, "Arial")
$DC1 = GUICtrlCreateLabel("Domain Controller 1:", 40, 552, 254, 36)
$DC2 = GUICtrlCreateLabel("Domain Controller 2:", 40, 608, 254, 36)
$Xserve = GUICtrlCreateLabel("XSERVE:", 40, 664, 120, 36)
$Datev = GUICtrlCreateLabel("Datev Server:", 40, 720, 170, 36)
$Zeus = GUICtrlCreateLabel("Zeus Server:", 40, 776, 160, 36)
$Easylog = GUICtrlCreateLabel("Easylog Server:", 40, 832, 196, 36)
$Dc1antwort = GUICtrlCreateLabel($srtantwortdc1, 316, 552, 126, 36)
$dc2antwort = GUICtrlCreateLabel($srtantwortdc2, 316, 608, 126, 36)
$xserveantwort = GUICtrlCreateLabel($srtantwortxserve, 316, 664, 126, 36)
$datevantwort = GUICtrlCreateLabel($srtantwortdatev, 316, 720, 126, 36)
$zeusantwort = GUICtrlCreateLabel($srtantwortzeus, 316, 776, 192, 36)
$easylogantwort = GUICtrlCreateLabel($srtantwortelog, 316, 832, 126, 36)

$Netwerkdiagnose = GUICtrlCreateLabel("Netzwerk Diagnose", 480, 448, 239, 36)
GUICtrlSetFont(-1, 20, 500, 0, "Arial")
;tab5
$DNS = GUICtrlCreateGroup("DNS", 664, 496, 617, 393)
GUICtrlSetFont(-1, 20, 400, 0, "Arial")
$hauptdns = GUICtrlCreateLabel("Haupt DNS Server:", 680, 552, 236, 36)
$GBDCHAT = GUICtrlCreateLabel("GBD Chat:", 680, 608, 137, 36)
$Goofle = GUICtrlCreateLabel("Google:", 680, 664, 99, 36)
$Label1 = GUICtrlCreateLabel($srtantwortdns1, 944, 552, 161, 36)
$gbdhactantwort = GUICtrlCreateLabel($srtantwortchat, 944, 608, 236, 36)
$googleantwort = GUICtrlCreateLabel($srtantwortgoogle, 944, 664, 236, 36)
;tab6
$INFO = GUICtrlCreateGroup("", 24, 888, 1257, 41)
$Label2 = GUICtrlCreateLabel("Autor: Thomas Zickert | © 2017  ", 48, 904, 200, 21)
GUICtrlSetFont(-1, 11, 400, 0, "Arial")
$Label3 = GUICtrlCreateLabel("Version" &" " & $ProgVersion, 1155, 904, 120, 22)
GUICtrlSetFont(-1, 12, 400, 0, "Arial")
$Button2_4 = GUICtrlCreateButton("Windows" & @CRLF & "Info", 250, 901,25,25,$BS_ICON)
GUICtrlSetImage(-1, "\\xserve\IT-Allgemein\_Programme Mac Win\Netzwerk Diagnose\ICO\2.ico")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

#CS############################
#####					  #####
#####  	  Label Farben    #####
#####                     #####
#CE############################


If $srtantwortdc1 = "Erreichbar" Then
	 GUICtrlSetColor($Dc1antwort, $COLOR_GREEN)
	 Else
	 GUICtrlSetColor($Dc1antwort, $COLOR_RED)
EndIf

If $srtantwortdc2 = "Erreichbar" Then
	 GUICtrlSetColor($dc2antwort, $COLOR_GREEN)
	 Else
	 GUICtrlSetColor($dc2antwort, $COLOR_RED)
EndIf

If $srtantwortxserve = "Erreichbar" Then
	 GUICtrlSetColor($xserveantwort, $COLOR_GREEN)
	 Else
	 GUICtrlSetColor($xserveantwort, $COLOR_RED)
EndIf

If $srtantwortdatev = "Erreichbar" Then
	 GUICtrlSetColor($datevantwort, $COLOR_GREEN)
	 Else
	 GUICtrlSetColor($datevantwort, $COLOR_RED)
EndIf

If $srtantwortzeus = "Erreichbar" Then
	GUICtrlSetColor($zeusantwort, $COLOR_GREEN)
	Else
	GUICtrlSetColor($zeusantwort, $COLOR_RED)
	EndIf

If $srtantwortelog = "Erreichbar" Then
	GUICtrlSetColor($easylogantwort, $COLOR_GREEN)
	Else
	GUICtrlSetColor($easylogantwort, $COLOR_RED)
EndIf

If $srtantwortdns1 = "Erreichbar" Then
	GUICtrlSetColor($Label1, $COLOR_GREEN)
	Else
	GUICtrlSetColor($Label1, $COLOR_RED)
EndIf

If $srtantwortchat = "Erreichbar" Then
	GUICtrlSetColor($gbdhactantwort, $COLOR_GREEN)
	Else
	GUICtrlSetColor($gbdhactantwort, $COLOR_RED)
EndIf

If $srtantwortgoogle = "Erreichbar" Then
	GUICtrlSetColor($googleantwort, $COLOR_GREEN)
	Else
	GUICtrlSetColor($googleantwort, $COLOR_RED)
EndIf



If $strlan = "Verbunden" Then
	GUICtrlSetColor($lanantwort, $COLOR_GREEN)
EndIf

If $strwlan = "Verbunden" Then
	GUICtrlSetColor($wlanantwort, $COLOR_GREEN)
EndIf






#CS#################
#####		   #####
#####  GUI 2   #####
#####		   #####
#CE#################



$gui2 = GUICreate("Netzwerkinfo", 1650, 374, 192, 124)
$Group1 = GUICtrlCreateGroup("Alle aktiven Adapter", 16, 16, 1615, 342)
GUICtrlSetFont(-1, 30, 800, 0, "Arial")
;GUICtrlCreateGroup("", -99, -99, 1, 1)

$ListView1 = GUICtrlCreateListView("Hersteller |Name|Adapter-Typ|Kennung|MAC Adresse|Adresstyp|DHCP-Server|IP erhalten|IP läuft ab|IP-Adresse|Subnetzmaske|Standardgateway", 28, 70, 1590, 270)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 110)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 250)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 2, 100)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 3, 210)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 4, 130)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 5, 150)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 6, 100)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 7, 70)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 8, 60)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 9, 100)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 10, 100)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 11, 106)




For $i = 1 To UBound($aAdapter) - 1
	$sString = ""

	For $j = 0 To UBound($aAdapter, 2) - 1
		$sString &= $aAdapter[$i][$j] & "|"
	Next

	$sString = StringTrimRight($sString, 1)

	GUICtrlCreateListViewItem($sString, $ListView1)
Next

$Button1_2 = GUICtrlCreateButton("zurück", 1560, 2, 85, 35, $WS_GROUP)
$Button2_5 = GUICtrlCreateButton("", 1360, 2,35,35,$BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 19)
$Button2_6 = GUICtrlCreateButton("", 1100, 2,35,35,$BS_ICON)
GUICtrlSetImage(-1, "DDORes.dll", 1)

$Netzwerkeinstellungen = GUICtrlCreateLabel("Adapter" & " " & "Einstellungen:", 1147, 8, 210, 25)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$geratemanager = GUICtrlCreateLabel("Geräte" & " " & "Manager:", 935, 8, 160, 25)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")


#CS#################
#####		   #####
#####  GUI 3   #####
#####		   #####
#CE#################

$gui3 = GUICreate("Info", 657, 830, 195, 124,$WS_EX_CLIENTEDGE);802
$uber = GUICtrlCreateGroup("Über", 16, 8, 617, 777)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$Programmname = GUICtrlCreateLabel("Netzwerk Diagnose Tool", 176, 56, 324, 36)
GUICtrlSetFont(-1, 20, 800, 0, "Arial")
$Programmico = GUICtrlCreateIcon("\\xserve\IT-Allgemein\_Programme Mac Win\Netzwerk Diagnose\ICO\NetzwerkDiagnose.ico", -1, 280, 104, 108, 108)
$Versioninfo = GUICtrlCreateLabel("Version" & $ProgVersion, 280, 224, 293, 28)
GUICtrlSetFont(-1, 12, 200, 0, "Arial")
GUISetFont(-1, 16, 800, 0, "Arial")
$Autor = GUICtrlCreateLabel("Autor", 304, 280, 53, 28)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$name = GUICtrlCreateLabel("Thomas Zickert", 256, 320, 148, 28)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$ort = GUICtrlCreateLabel("Gifhorn, Deutschland", 232, 352, 199, 28)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$Lizenz = GUICtrlCreateLabel("Lizenz:", 296, 432, 68, 28)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$Label1 = GUICtrlCreateLabel("© 2017 Thomas Zickert, Druckhaus Harms e.K." & @CRLF & "Nutzung und Vervielfältigung nur für Mitarbeiter des Druckhaus Harms e.K. gestattet", 70, 480, 500, 200,$SS_CENTER)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$Label15 = GUICtrlCreateLabel("Kontakt:" &" ", 275, 383, 80, 28)
GUICtrlSetFont(-1, 16, 400, 0, "Arial")
$Button2_7 = GUICtrlCreateButton("", 355, 383,35,25,$BS_ICON);Mail
GUICtrlSetImage(-1, "imageres.dll",20)
$Button1_3 = GUICtrlCreateButton("OK und zurück", 280, 770, 100, 25)


While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $Button2_1
			GUISetState(@SW_HIDE, $gui1)
			GUISetState(@SW_SHOW, $gui2)
		Case $Button1_2
			GUISetState(@SW_HIDE, $gui2)
			GUISetState(@SW_SHOW, $gui1)
		;Case $Button2_2
		;	ShellExecute ("devmgmt.msc")
		Case $Button2_3
			ShellExecute ("devmgmt.msc")
		Case $Button1_3
			GUISetState(@SW_HIDE, $gui3)
		Case $Button2_4
			GUISetState(@SW_SHOW, $gui3)
		Case $Button2_5
			ShellExecute ("ncpa.cpl")
		Case $Button2_10
			ShellExecute ("ncpa.cpl")
		Case $Button2_6
			ShellExecute ("devmgmt.msc")
		Case $Button2_7
			MsgBox (0,"Kontakt", "Email:"&" "&"zickert.thomas@gbd24.de")
	EndSwitch
WEnd

;@SW_SHOWNA für skalierung
;@OSServicePack
;@DesktopRefresh
